/******************************************************************************* 
 * main.h - SNES9x PS3
 *
 *  Created on: Oct 11, 2010
 *      Author: halsafar
 *      Author: Squarepusher2
********************************************************************************/

#ifndef EMULATOR_H_
#define EMULATOR_H_

#define AUDIO_INPUT_RATE (48000)
#define AUDIO_BUFFER_SAMPLES (4096)
#define EMULATOR_VERSION "4.4.4"

#include "cellframework/audio/audioport.hpp"
#include "cellframework/audio/rsound.hpp"
#include "cellframework/input/cellInput.h"
#include "SNES9xGraphics.h"
#include "ps3input.h"

enum Emulator_Modes
{
	MODE_MENU,
	MODE_EMULATION,
	MODE_EXIT
};

enum Emulator_ControllerModes
{
	NO_JOYSTICKS = 0x1,
	TWO_JOYSTICKS = 0x2,
	MULTITAP = 0x4,
	MOUSE = 0x8,
	SUPERSCOPE = 0x10,
	JUSTIFIER = 0x20,
	TWO_JUSTIFIERS = 0x40
};

float Emulator_GetFontSize();
void Emulator_SetControllerMode(Emulator_ControllerModes);
Emulator_ControllerModes Emulator_GetControllerMode(void);
void Emulator_RequestLoadROM(char* rom, bool forceReload);
int Emulator_LoadSettings();
int Emulator_SaveSettings();
bool Emulator_IsROMLoaded();
void Emulator_SwitchMode(Emulator_Modes);
void Emulator_Shutdown();
void Emulator_StopAudio();
void Emulator_PlayAudio();
char * Emulator_GetROM();
void Emulator_StopROMRunning();
void Emulator_StartROMRunning();
void Emulator_SetDebugMessage(const char * value);
void Emulator_GraphicsInit(uint32_t resId);
bool Emulator_IsInitialized();
bool Emulator_ROMRunning();
bool Emulator_OSKStart(const wchar_t* msg, const wchar_t* init);
void Emulator_OSKClose();
bool Emulator_OSKIsRunning();
const char * Emulator_OSKOutputString();
extern CellInputFacade* CellInput;
extern SNES9xGraphics* Graphics;
extern Audio::Stream<int16_t>* CellAudio;
#endif /* EMULATOR_H_ */
