/******************************************************************************* 
 * menu.h - SNES9x PS3
 *
 *  Created on: Oct 10, 2010
 *      Author: halsafar
 *	Author: Squarepusher2
********************************************************************************/

#ifndef MENU_H_
#define MENU_H_

#include <string>
#include "colors.h"

#define FIRST_GENERAL_SETTING	0
#define FIRST_SNES9X_SETTING	50
#define FIRST_PATH_SETTING	100
#define FIRST_CONTROLS_SETTING	150

//GENERAL - setting constants
enum
{
	SETTING_CURRENT_SAVE_STATE_SLOT = FIRST_GENERAL_SETTING,
	SETTING_CHANGE_RESOLUTION,
	SETTING_SHADER,
	SETTING_FONT_SIZE,
	SETTING_KEEP_ASPECT_RATIO,
	SETTING_HW_TEXTURE_FILTER,
	SETTING_HW_OVERSCAN_AMOUNT,
	SETTING_RSOUND_ENABLED,
	SETTING_RSOUND_SERVER_IP_ADDRESS,
	SETTING_THROTTLE_MODE,
	SETTING_DEFAULT_ALL
};

//SNES9X  - setting constants
enum
{
	SETTING_SNES9X_FPS			= FIRST_SNES9X_SETTING,
	SETTING_SNES9X_SOUND_INPUT_RATE,
	SETTING_SNES9X_TRANSPARENCY,
	SETTING_SNES9X_SKIP_FRAMES,
	SETTING_SNES9X_DISABLE_GRAPHIC_WINDOWS,
	SETTING_SNES9X_DISPLAY_PRESSED_KEYS,
	SETTING_SNES9X_FORCE_PAL,
	SETTING_SNES9X_FORCE_NTSC,
	SETTING_SNES9X_PAL_TIMING,
	SETTING_SNES9X_AUTO_APPLY_CHEATS,
	SETTING_SNES9X_AUTO_APPLY_PATCH,
	SETTING_SNES9X_RESET_BEFORE_RECORDING_MOVIE,
	SETTING_SNES9X_SRAM_WRITEPROTECT,
	SETTING_SNES9X_TURBO_SKIP_FRAMES,
	SETTING_SNES9X_ACCESSORY_AUTODETECTION,
	SETTING_SNES9X_DEFAULT_ALL
};
	
//PATH - setting constants
enum
{
	SETTING_PATH_DEFAULT_ROM_DIRECTORY = FIRST_PATH_SETTING,
	SETTING_PATH_SAVESTATES_DIRECTORY,
	SETTING_PATH_SRAM_DIRECTORY,
	SETTING_PATH_CHEATS,
	SETTING_PATH_DEFAULT_ALL
};

//CONTROLS - setting constants
enum
{
	SETTING_CONTROLS_SCHEME = FIRST_CONTROLS_SETTING,
	SETTING_CONTROLS_DPAD_UP,
	SETTING_CONTROLS_DPAD_DOWN,
	SETTING_CONTROLS_DPAD_LEFT,
	SETTING_CONTROLS_DPAD_RIGHT,
	SETTING_CONTROLS_BUTTON_CIRCLE,
	SETTING_CONTROLS_BUTTON_CROSS,
	SETTING_CONTROLS_BUTTON_TRIANGLE,
	SETTING_CONTROLS_BUTTON_SQUARE,
	SETTING_CONTROLS_BUTTON_SELECT,
	SETTING_CONTROLS_BUTTON_START,
	SETTING_CONTROLS_BUTTON_L1,
	SETTING_CONTROLS_BUTTON_R1,
	SETTING_CONTROLS_BUTTON_L2,
	SETTING_CONTROLS_BUTTON_R2,
	SETTING_CONTROLS_BUTTON_L3,
	SETTING_CONTROLS_BUTTON_R3,
	SETTING_CONTROLS_BUTTON_L2_BUTTON_L3,
	SETTING_CONTROLS_BUTTON_L2_BUTTON_R2,
	SETTING_CONTROLS_BUTTON_L2_BUTTON_R3,
	SETTING_CONTROLS_BUTTON_L2_ANALOG_R_RIGHT,
	SETTING_CONTROLS_BUTTON_L2_ANALOG_R_LEFT,
	SETTING_CONTROLS_BUTTON_L2_ANALOG_R_UP,
	SETTING_CONTROLS_BUTTON_L2_ANALOG_R_DOWN,
	SETTING_CONTROLS_BUTTON_R2_ANALOG_R_RIGHT,
	SETTING_CONTROLS_BUTTON_R2_ANALOG_R_LEFT,
	SETTING_CONTROLS_BUTTON_R2_ANALOG_R_UP,
	SETTING_CONTROLS_BUTTON_R2_ANALOG_R_DOWN,
	SETTING_CONTROLS_BUTTON_R2_BUTTON_R3,
	SETTING_CONTROLS_BUTTON_R3_BUTTON_L3,
	SETTING_CONTROLS_ANALOG_R_UP,
	SETTING_CONTROLS_ANALOG_R_DOWN,
	SETTING_CONTROLS_ANALOG_R_LEFT,
	SETTING_CONTROLS_ANALOG_R_RIGHT,
	SETTING_CONTROLS_SAVE_CUSTOM_CONTROLS,
	SETTING_CONTROLS_DEFAULT_ALL
};


//GENERAL - Total amount of settings
#define MAX_NO_OF_SETTINGS				SETTING_DEFAULT_ALL+1
//SNES9x - Total amount of SNES9x settings
#define MAX_NO_OF_SNES9X_SETTINGS			SETTING_SNES9X_DEFAULT_ALL+1
// PATH - Total amount of Path settings
#define MAX_NO_OF_PATH_SETTINGS				SETTING_PATH_DEFAULT_ALL+1
//CONTROLS - Total amount of controls settings
#define MAX_NO_OF_CONTROLS_SETTINGS			SETTING_CONTROLS_DEFAULT_ALL+1

void MenuMainLoop(void);

void MenuStop();
bool MenuIsRunning();
char* MenuGetSelectedROM();
char* MenuGetCurrentPath();
char* do_pathmenu(uint16_t is_for_shader_or_dir_selection, const char * pathname = "/");

#endif /* MENU_H_ */
